<template>
	<a-card :bordered="false">
		<a-form ref="searchFormRef" name="advanced_search" :model="searchFormState" class="ant-advanced-search-form mb-4">
			<a-row :gutter="24">
				<a-col :span="4">
					<a-form-item label="企业客户" name="depotId">
						<a-select v-model:value="searchFormState.depotId" placeholder="请选择企业客户" :options="depotOptions"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-form-item label="审批状态" name="bankOpApprovalState">
						<a-select v-model:value="searchFormState.bankOpApprovalState" placeholder="请选择企业客户" :options="bankOpApprovalStateOptions"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-form-item label="锁名称" name="lockName">
						<a-input v-model:value="searchFormState.lockName" placeholder="请输入锁名称"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-form-item label="描述" name="remark">
						<a-input v-model:value="searchFormState.remark" placeholder="请输入描述"/>
					</a-form-item>
				</a-col>
				<a-col :span="6">
					<a-button type="primary" @click="table.refresh(true)">查询</a-button>
					<a-button style="margin: 0 8px" @click="() => searchFormRef.resetFields()">重置</a-button>
					<a @click="toggleAdvanced" style="margin-left: 8px">
						{{ advanced ? '收起' : '展开' }}
						<component :is="advanced ? 'up-outlined' : 'down-outlined'"/>
					</a>
				</a-col>
			</a-row>
		</a-form>
		<s-table
			ref="table"
			:columns="columns"
			:data="loadData"
			:alert="options.alert.show"
			bordered
			:row-key="(record) => record.id"
			:tool-config="toolConfig"
			:row-selection="options.rowSelection"
		>
			<template #operator class="table-operator">
				<a-space>
					<a-button type="primary" @click="formRef.onOpen()" v-if="hasPerm('depotLockBookAdd')">
						<template #icon>
							<plus-outlined/>
						</template>
						新增
					</a-button>
					<a-button danger @click="deleteBatchDepotLockBook()" v-if="hasPerm('depotLockBookBatchDelete')">删除</a-button>
				</a-space>
			</template>
			<template #bodyCell="{ column, record }">
				<template v-if="column.dataIndex === 'action'">
					<a @click="detailFormRef.onOpen(record)"><span>详情</span>
					</a>
					<a @click="bankOpApprovalFormRef.onOpen(record)" v-if="hasPerm('depotLockBookankOpApprovalState') && record.bankOpApprovalState === '待审批'">
						<a-divider type="vertical"/>
						<span>审批</span>
					</a>
					<a @click="formRef.onOpen(record)" v-if="hasPerm('depotLockBookEdit') && record.bankOpApprovalState === '待审批'">
						<a-divider type="vertical"/>
						<span>编辑</span>
					</a>
					<a-popconfirm title="确定要删除吗？" @confirm="deleteDepotLockBook(record)">
						<a-button type="link" danger size="small" v-if="hasPerm('depotLockBookDelete') && record.bankOpApprovalState === '待审批'">
							<a-divider type="vertical"/>
							<span>删除</span>
						</a-button>
					</a-popconfirm>
				</template>
			</template>
		</s-table>
	</a-card>
	<Form ref="formRef" @successful="table.refresh(true)"/>
	<DetailForm ref="detailFormRef"/>
	<BankOpApprovalFormForm ref="bankOpApprovalFormRef" @successful="table.refresh(true)"/>
</template>

<script setup name="depotLockBook">
import {message} from 'ant-design-vue'
import tool from '@/utils/tool'
import Form from './form.vue'
import DetailForm from './detailForm.vue'
import BankOpApprovalFormForm from './bankOpApprovalForm.vue'
import depotLockBookApi from '@/api/biz/depotLockBookApi'
import dictOptionsApi from "@/api/biz/dictOptionsApi";

let searchFormState = reactive({})
const searchFormRef = ref()
const table = ref()
const formRef = ref()
const detailFormRef = ref()
const bankOpApprovalFormRef = ref()
const toolConfig = {refresh: true, height: true, columnSetting: true, striped: false}
const depotOptions = ref([])
// 查询区域显示更多控制
const advanced = ref(false)
const toggleAdvanced = () => {
	advanced.value = !advanced.value
}
const columns = [
	{
		title: '企业客户',
		dataIndex: 'depotGrainName'
	},
	{
		title: '库位',
		dataIndex: 'shedName'
	},
	{
		title: '锁名称',
		dataIndex: 'lockName'
	},
	{
		title: '描述',
		dataIndex: 'remark'
	},
	{
		title: '审批状态',
		dataIndex: 'bankOpApprovalState'
	},
	{
		title: '预约时间',
		dataIndex: 'createTime'
	},
]
// 操作栏通过权限判断是否显示
if (hasPerm(['depotLockBookankOpApprovalState', 'depotLockBookEdit', 'depotLockBookDelete'])) {
	columns.push({
		title: '操作',
		dataIndex: 'action',
		align: 'center',
		width: '150px'
	})
}
let selectedRowKeys = ref([])
// 列表选择配置
const options = {
	alert: {
		show: false,
		clear: () => {
			selectedRowKeys = ref([])
		}
	},
	rowSelection: {
		onChange: (selectedRowKey, selectedRows) => {
			selectedRowKeys.value = selectedRowKey
		}
	}
}
dictOptionsApi.options(Object.assign('', {'dictValue': '粮库'})).then((data) => {
	depotOptions.value = data
})
const loadData = (parameter) => {
	const searchFormParam = JSON.parse(JSON.stringify(searchFormState))
	return depotLockBookApi.depotLockBookPage(Object.assign(parameter, searchFormParam)).then((data) => {
		return data
	})
}
// 二级审批通过
const bankOpApprovalState = (record) => {
	depotLockBookApi.bankOpApproval({id: record.id}).then(() => {
		table.value.refresh(true)
	})
}
// 删除
const deleteDepotLockBook = (record) => {
	let params = [
		{
			id: record.id
		}
	]
	depotLockBookApi.depotLockBookDelete(params).then(() => {
		table.value.refresh(true)
	})
}
// 批量删除
const deleteBatchDepotLockBook = () => {
	if (selectedRowKeys.value.length < 1) {
		message.warning('请选择一条或多条数据')
		return false
	}
	const params = selectedRowKeys.value.map((m) => {
		return {
			id: m
		}
	})
	depotLockBookApi.depotLockBookDelete(params).then(() => {
		table.value.clearRefreshSelected()
	})
}
const bankOpApprovalStateOptions = tool.dictList('审批通过状态')
</script>
